﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CheckSumAdjuster
{
    class Program
    {
        static int[] block = { 0x00030A00, 0x00032200, 0x00033B00, 0x00035300, 0x00036C00, 0x00037800 };
        static int[] size = { 6000, 6000, 6000, 6000, 2940, 2940 };


        static void Main(string[] args)
        {
            // ファイルを読み込む
            byte[] save = System.IO.File.ReadAllBytes(args[0]);

            for (int i = 0; i < block.Length; i++)
            {
                Console.Write("Block " + (i + 1));
                // ブロックを使用しているかをチェックする
                byte[] str = new byte[8];
                for (int j = 0; j < str.Length; j++)
                {
                    str[j] = save[block[i] + j];
                }
                if (System.Text.Encoding.ASCII.GetString(str).ToUpper() != "PAWAPOKE")
                {
                    Console.WriteLine(" Not Use");
                    continue;
                }

                // データ部を配列に入れる
                byte[] data = new byte[size[i]];
                for (int j = 0; j < data.Length; j++)
                {
                    data[j] = save[block[i] + j + 0x20];
                }
                // データ部のSHA-1ハッシュ値を計算する
                System.Security.Cryptography.SHA1CryptoServiceProvider sha1 = new System.Security.Cryptography.SHA1CryptoServiceProvider();
                byte[] hash = sha1.ComputeHash(data);
                for (int j = 0; j < 0x10; j++)
                {
                    save[block[i] + j + 0x10] = hash[j];
                }

                // サムを初期化する
                save[block[i] + 0x0E] = 0;
                save[block[i] + 0x0F] = 0;
                // サムを計算する
                int sum = 0;
                for (int j = 0; j < 0x20; j++)
                {
                    sum += save[block[i] + j++];
                    sum += save[block[i] + j] << 8;
                }
                for (int j = 0; j < 2; j++)
                {
                    sum = (sum & 0xFFFF) + (sum >> 16);
                }
                sum = sum ^ 0xFFFF;
                save[block[i] + 0x0E] = (byte)(sum & 0xFF);
                save[block[i] + 0x0F] = (byte)(sum >> 8);

                Console.WriteLine(" Adjust");
            }

            // ファイルを書き出す
            System.IO.File.WriteAllBytes(args[0], save);
        }


    }
}
